Index: lemon/capacity_scaling.h
===================================================================
--- lemon/capacity_scaling.h	(revision 811)
+++ lemon/capacity_scaling.h	(revision 812)
@@ -36,7 +36,7 @@
   /// Default traits class of CapacityScaling algorithm.
   /// \tparam GR Digraph type.
-  /// \tparam V The value type used for flow amounts, capacity bounds
+  /// \tparam V The number type used for flow amounts, capacity bounds
   /// and supply values. By default it is \c int.
-  /// \tparam C The value type used for costs and potentials.
+  /// \tparam C The number type used for costs and potentials.
   /// By default it is the same as \c V.
   template <typename GR, typename V = int, typename C = V>
@@ -76,10 +76,10 @@
   ///
   /// \tparam GR The digraph type the algorithm runs on.
-  /// \tparam V The value type used for flow amounts, capacity bounds
+  /// \tparam V The number type used for flow amounts, capacity bounds
   /// and supply values in the algorithm. By default it is \c int.
-  /// \tparam C The value type used for costs and potentials in the
+  /// \tparam C The number type used for costs and potentials in the
   /// algorithm. By default it is the same as \c V.
   ///
-  /// \warning Both value types must be signed and all input data must
+  /// \warning Both number types must be signed and all input data must
   /// be integer.
   /// \warning This algorithm does not support negative costs for such
@@ -123,5 +123,5 @@
       /// The digraph contains an arc of negative cost and infinite
       /// upper bound. It means that the objective function is unbounded
-      /// on that arc, however note that it could actually be bounded
+      /// on that arc, however, note that it could actually be bounded
       /// over the feasible flows, but this algroithm cannot handle
       /// these cases.
@@ -308,5 +308,5 @@
           std::numeric_limits<Value>::max())
     {
-      // Check the value types
+      // Check the number types
       LEMON_ASSERT(std::numeric_limits<Value>::is_signed,
         "The flow type of CapacityScaling must be signed");
@@ -412,5 +412,5 @@
     /// If it is not used before calling \ref run(), the upper bounds
     /// will be set to \ref INF on all arcs (i.e. the flow value will be
-    /// unbounded from above on each arc).
+    /// unbounded from above).
     ///
     /// \param map An arc map storing the upper bounds.
@@ -515,5 +515,5 @@
     /// \ref reset() is called, thus only the modified parameters
     /// have to be set again. See \ref reset() for examples.
-    /// However the underlying digraph must not be modified after this
+    /// However, the underlying digraph must not be modified after this
     /// class have been constructed, since it copies and extends the graph.
     ///
@@ -528,5 +528,5 @@
     /// \n \c UNBOUNDED if the digraph contains an arc of negative cost
     /// and infinite upper bound. It means that the objective function
-    /// is unbounded on that arc, however note that it could actually be
+    /// is unbounded on that arc, however, note that it could actually be
     /// bounded over the feasible flows, but this algroithm cannot handle
     /// these cases.
Index: lemon/cost_scaling.h
===================================================================
--- lemon/cost_scaling.h	(revision 810)
+++ lemon/cost_scaling.h	(revision 812)
@@ -41,7 +41,7 @@
   /// Default traits class of CostScaling algorithm.
   /// \tparam GR Digraph type.
-  /// \tparam V The value type used for flow amounts, capacity bounds
+  /// \tparam V The number type used for flow amounts, capacity bounds
   /// and supply values. By default it is \c int.
-  /// \tparam C The value type used for costs and potentials.
+  /// \tparam C The number type used for costs and potentials.
   /// By default it is the same as \c V.
 #ifdef DOXYGEN
@@ -102,10 +102,10 @@
   ///
   /// \tparam GR The digraph type the algorithm runs on.
-  /// \tparam V The value type used for flow amounts, capacity bounds
+  /// \tparam V The number type used for flow amounts, capacity bounds
   /// and supply values in the algorithm. By default it is \c int.
-  /// \tparam C The value type used for costs and potentials in the
+  /// \tparam C The number type used for costs and potentials in the
   /// algorithm. By default it is the same as \c V.
   ///
-  /// \warning Both value types must be signed and all input data must
+  /// \warning Both number types must be signed and all input data must
   /// be integer.
   /// \warning This algorithm does not support negative costs for such
@@ -158,5 +158,5 @@
       /// The digraph contains an arc of negative cost and infinite
       /// upper bound. It means that the objective function is unbounded
-      /// on that arc, however note that it could actually be bounded
+      /// on that arc, however, note that it could actually be bounded
       /// over the feasible flows, but this algroithm cannot handle
       /// these cases.
@@ -326,5 +326,5 @@
           std::numeric_limits<Value>::max())
     {
-      // Check the value types
+      // Check the number types
       LEMON_ASSERT(std::numeric_limits<Value>::is_signed,
         "The flow type of CostScaling must be signed");
@@ -434,5 +434,5 @@
     /// If it is not used before calling \ref run(), the upper bounds
     /// will be set to \ref INF on all arcs (i.e. the flow value will be
-    /// unbounded from above on each arc).
+    /// unbounded from above).
     ///
     /// \param map An arc map storing the upper bounds.
@@ -550,5 +550,5 @@
     /// \n \c UNBOUNDED if the digraph contains an arc of negative cost
     /// and infinite upper bound. It means that the objective function
-    /// is unbounded on that arc, however note that it could actually be
+    /// is unbounded on that arc, however, note that it could actually be
     /// bounded over the feasible flows, but this algroithm cannot handle
     /// these cases.
@@ -572,5 +572,5 @@
     /// used, all the parameters given before are kept for the next
     /// \ref run() call.
-    /// However the underlying digraph must not be modified after this
+    /// However, the underlying digraph must not be modified after this
     /// class have been constructed, since it copies and extends the graph.
     ///
Index: lemon/network_simplex.h
===================================================================
--- lemon/network_simplex.h	(revision 811)
+++ lemon/network_simplex.h	(revision 812)
@@ -44,11 +44,11 @@
   /// \ref amo93networkflows, \ref dantzig63linearprog,
   /// \ref kellyoneill91netsimplex.
-  /// This algorithm is a specialized version of the linear programming
-  /// simplex method directly for the minimum cost flow problem.
-  /// It is one of the most efficient solution methods.
+  /// This algorithm is a highly efficient specialized version of the
+  /// linear programming simplex method directly for the minimum cost
+  /// flow problem.
   ///
-  /// In general this class is the fastest implementation available
-  /// in LEMON for the minimum cost flow problem.
-  /// Moreover it supports both directions of the supply/demand inequality
+  /// In general, %NetworkSimplex is the fastest implementation available
+  /// in LEMON for this problem.
+  /// Moreover, it supports both directions of the supply/demand inequality
   /// constraints. For more information, see \ref SupplyType.
   ///
@@ -59,10 +59,10 @@
   ///
   /// \tparam GR The digraph type the algorithm runs on.
-  /// \tparam V The value type used for flow amounts, capacity bounds
+  /// \tparam V The number type used for flow amounts, capacity bounds
   /// and supply values in the algorithm. By default, it is \c int.
-  /// \tparam C The value type used for costs and potentials in the
+  /// \tparam C The number type used for costs and potentials in the
   /// algorithm. By default, it is the same as \c V.
   ///
-  /// \warning Both value types must be signed and all input data must
+  /// \warning Both number types must be signed and all input data must
   /// be integer.
   ///
@@ -127,5 +127,5 @@
     /// By default, \ref BLOCK_SEARCH "Block Search" is used, which
     /// proved to be the most efficient and the most robust on various
-    /// test inputs according to our benchmark tests.
+    /// test inputs.
     /// However, another pivot rule can be selected using the \ref run()
     /// function with the proper parameter.
@@ -638,5 +638,5 @@
           std::numeric_limits<Value>::infinity() : MAX)
     {
-      // Check the value types
+      // Check the number types
       LEMON_ASSERT(std::numeric_limits<Value>::is_signed,
         "The flow type of NetworkSimplex must be signed");
@@ -730,5 +730,5 @@
     /// If it is not used before calling \ref run(), the upper bounds
     /// will be set to \ref INF on all arcs (i.e. the flow value will be
-    /// unbounded from above on each arc).
+    /// unbounded from above).
     ///
     /// \param map An arc map storing the upper bounds.